AutoSeededRandomPool Class Reference

Automatically Seeded Randomness Pool. More...

`#include <osrng.h>`

Inheritance diagram for AutoSeededRandomPool:

## Public Member Functions

| AutoSeededRandomPool (bool blocking=false, unsigned int seedSize=32)
| Construct an AutoSeededRandomPool.
void | Reseed (bool blocking=false, unsigned int seedSize=32)
| Reseed an AutoSeededRandomPool.
Public Member Functions inherited from RandomPool
| RandomPool ()
| Construct a RandomPool.
bool | CanIncorporateEntropy () const
| Determines if a generator can accept additional entropy.
void | IncorporateEntropy (const byte *input, size_t length)
| Update RNG state with additional unpredictable values.
void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword size)
| Generate random bytes into a BufferedTransformation.
Public Member Functions inherited from RandomNumberGenerator
virtual byte | GenerateByte ()
| Generate new random byte and return it.
virtual unsigned int | GenerateBit ()
| Generate new random bit and return it.
virtual word32 | GenerateWord32 (word32 min=0, word32 max=0xffffffffUL)
| Generate a random 32 bit word in the range min to max, inclusive.
virtual void | GenerateBlock (byte *output, size_t size)
| Generate random array of bytes.
virtual void | DiscardBytes (size_t n)
| Generate and discard n bytes.
template<class IT >
void | Shuffle (IT begin, IT end)
| Randomly shuffle the specified array.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm.
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.

## Static Public Member Functions

static const char * | StaticAlgorithmName ()

## Detailed Description

Automatically Seeded Randomness Pool.

This class seeds itself using an operating system provided RNG. AutoSeededRandomPool was suggested by Leonard Janke.

You should reseed the generator after a fork() to avoid multiple generators with the same internal state.

Definition at line 158 of file osrng.h.

## Constructor & Destructor Documentation

## ~AutoSeededRandomPool()

AutoSeededRandomPool::~AutoSeededRandomPool | ( |  | ) |

inline

Definition at line 163 of file osrng.h.

## AutoSeededRandomPool()

AutoSeededRandomPool::AutoSeededRandomPool | ( | bool | blocking = `false`,
|  | unsigned int | seedSize = `32`
| ) |  |

inline explicit

Construct an AutoSeededRandomPool.

Parameters

  blocking | controls seeding with BlockingRng or NonblockingRng
  seedSize | the size of the seed, in bytes

Use blocking to choose seeding with BlockingRng or NonblockingRng. The parameter is ignored if only one of these is available.

Definition at line 170 of file osrng.h.

## Member Function Documentation

## StaticAlgorithmName()

static const char * AutoSeededRandomPool::StaticAlgorithmName | ( |  | ) |

inline static

Definition at line 161 of file osrng.h.

## Reseed()

void AutoSeededRandomPool::Reseed | ( | bool | blocking = `false`,
|  | unsigned int | seedSize = `32`
| ) |  |

Reseed an AutoSeededRandomPool.

Parameters

  blocking | controls seeding with BlockingRng or NonblockingRng
  seedSize | the size of the seed, in bytes

The documentation for this class was generated from the following file:

- osrng.h